#include <stdio.h>
#include <math.h>

double r[8], h[8], xmin;
int a[8], b[8];

void permuta(int i, int m)
{
  int j, k;
  double x;

  if (i == m) {
    x = 0.0;
    for (j = 0; j < m; j++) {
      if (x < h[j] + r[a[j]])
        x = h[j] + r[a[j]];
    }
    if (x < xmin)
      xmin = x;
  } else {
    for (j = 0; j < m; j++)
      if (!b[j]) {
	b[j] = 1;
	a[i] = j;
        h[i] = r[j];
        for (k = 0; k < i; k++) {
          x = h[k] + 2.0*sqrt(r[a[k]]*r[j]);
          if (x > h[i]) h[i] = x;
        }
	permuta(i+1, m);
	b[j] = 0;
      }
  }
}

int main(void)
{
  int i, j, m, n;

  scanf("%d", &n);
  for (i = 0; i < n; i++) {
    scanf("%d", &m);
    xmin = 0.0;
    for (j = 0; j < m; j++) {
      scanf("%lf", &r[j]);
      xmin += 2.0*r[j];
      b[j] = 0;
    }
    permuta(0, m);
    printf("%.3f\n", xmin);
  }
  return 0;
}
